unit gNfrServe;

// what are we being asked to serve? (search monitor)

(****************************************************************
Copyright (C)2000, Michael Ax. Created 2000. All rights reserved.
License to copy, use also for making and using derivative works
of this software is granted provided that that such works are
identified as "derived from the GnutViewer project" in all material
mentioning or referencing the derived work. Michael Ax makes no
representations concerning either the merchantability of this software
or the suitability of this software for any particular purpose. It is
provided "as is" without express or implied warranty of any kind.
These notices must be retained in this documentation and/or software.
*****************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gNutFrame, gNutella, StdCtrls, ExtCtrls;

type
  TgNutServe = class(TGnutellaCustomFrame)
    Memo1: TMemo;
    Panel1: TPanel;
    edSpeed: TEdit;
    Label1: TLabel;
    cbAll: TCheckBox;
    cbTrack: TCheckBox;
    procedure edSpeedExit(Sender: TObject);
    procedure cbTrackClick(Sender: TObject);
    procedure cbAllClick(Sender: TObject);
  private
    { Private declarations }
    iSpeed: integer;
    bAll,bTrack: boolean;
    procedure SearchReq(MinSpeed: Word; const Search: String);
  public
    { Public declarations }
    procedure Init(aGnuTella: TGnuTellaTrans); override;
    end;

var
  gNutServe: TgNutServe;

implementation

{$R *.DFM}

procedure TgNutServe.Init(aGnuTella: TGnuTellaTrans);
begin
  inherited Init(aGnuTella);
  with gNutella do begin
    OnSearchReq:= SearchReq;
    end;
  edSpeedExit(nil);
  cbTrackClick(nil);
  cbAllClick(nil);
end;

procedure TgNutServe.SearchReq(MinSpeed: Word; const Search: String);
var
  i:integer;
begin
  if bTrack
  then
  if bAll
  or (iSpeed=0)
  or (iSpeed>=MinSpeed) then
    with memo1.lines do begin
      i:= indexof(Search);
      if i>-1 then
        move(i,0)
      else begin
        insert(0,Search);
        if Count>nLines then
          Delete(pred(Count));
        end;
      end;
end;


procedure TgNutServe.edSpeedExit(Sender: TObject);
begin
  inherited;
  with edSpeed do begin
    iSpeed:= strtointdef(Text,0);
    Text:= inttostr(iSpeed);
    end;
end;

procedure TgNutServe.cbTrackClick(Sender: TObject);
begin
  inherited;
  bTrack:= cbTrack.Checked;
end;

procedure TgNutServe.cbAllClick(Sender: TObject);
begin
  inherited;
  bAll:= cbAll.Checked;
end;

end.

